component-section
  div(slot='title') 🗂️ Data
  component-section
    div(slot='title') Abstract data types
    p
      | Een
      |
      em.term abstract data type
      |
      | (
      em.term adt
      | ) is een abstractie voor het bewaren van data met software.
      | Het begrip adt is een afspraak om
    ul
      li een bewaarvorm voor een bepaalde soort data overal dezelfde naam te geven,
      li
        | waarbij er minstens een bepaalde set
        |
        em.term operaties
        |
        | op de data mogelijk moet zijn.
    p
      | Een operatie is bijvoorbeeld een element toevoegen (en die operatie heet dan bijvoorbeeld
      |
      code insert
      |
      | of
      |
      code add
      | ), of zoeken naar een element binnen de datastructuur (
      code search
      | ).
    p
      | Kortom, een adt is dus een soort interface voor data, en de operaties erop zijn methods.
      | Maar
      |
      em adt
      |
      | is een programmeertaalonafhankelijk concept, in tegenstelling tot
      |
      em interface
      | .
    p Deze bron van MIT legt een aantal aspecten dieper uit:
    ul
      li
        p Wat ‘abstract’ inhoudt bij het concept adt.
      li
        p In hoeverre een adt algemeen (generiek) is.
      li
        p Hoe in Java interfaces als adt’s gebruikt kunnen worden.
    p.bron
      a(href='http://web.mit.edu/6.005/www/fa14/classes/08-abstract-data-types/') Reading 8: Abstract Data Types
  component-section
    div(slot='title') Datastructuren
    p
      | Waar een adt abstract en formeel is, is een
      |
      em.term datastructuur
      |
      | een concrete implementatie, uitgedrukt in broncode en gebonden aan een concrete geheugenindeling.
      | Adt’s kunnen op verschillende manieren worden geïmplementeerd, zelfs binnen programmeertalen.
      | Het resultaat van het implementeren is een datastructuur.
    p
      | Een
      |
      em.term datastructuur
      |
      | is opgeslagen in computergeheugen (→ data) en opgebouwd uit
      |
      em.term datatypes
      |
      | (→ structuur).
      | Doordat een datastructuur is opgeslagen in het geheugen, hangt de concrete vorm van datastructuren af van de hardware en de programmeertaalimplementatie.
    p
      | Een
      |
      em.term datatype
      |
      | is bijvoorbeeld een class met data-velden, in Java.
    // TODO: Illustratie toevoegen over datastructuur, datatype.
    p
      | Een
      |
      em.term primitief datatype
      |
      | is simpeler dan zo’n class.
      | De betekenis van primitief datatype hangt af van de programmeertaal, maar ‘getal’ (bijvoorbeeld
      |
      code.lang-java int
      | ) of ‘karakter’ (
      code.lang-java char
      | ) zijn bijna altijd wel beschikbaar.
      | Simpelere data types dan primitieve bestaan nooit.
    p.bron
      | The Java® Language Specification - Java SE 17 Edition
      cite(data-id='6867189/LGMREFR6', data-label='section', data-locator='4.2')
      |
      | (
      a(href='https://docs.oracle.com/javase/specs/jls/se17/html/jls-4.html#jls-4.2') Primitive Types and Values
      | )
    p
      | Een datastructuur is in broncode niet per se een class, en hoeft ook geen adt-interface te implementeren.
      | Dat hangt helemaal ervan af of de programmeertaal bijvoorbeeld objectgeoriënteerd is.
    p
      | Een standaarddatastructuur is in deze course een datastructuur die fundamenteel en basaal is binnen de informatica.
    p
      | OpenDSA licht de verbanden toe tussen onder meer adt, datastructuur en datatype vanuit een programmeertaalperspectief:
    p.bron
      a(href='https://opendsa-server.cs.vt.edu/OpenDSA/Books/Everything/html/ADT.html#adt') 4.1. Abstract Data Types
    component-section
      div(slot='title') Waarom je adt’s en datastructuren leert
      p.praktijk
        | De standaard-adt’s waar je in dit hoofdstuk over leert beschrijven de functionaliteit van datastructuren in vele implementaties.
        | Zelfs als je algoritmes niet zelf implementeert, maar alleen aanroept, moet je alsnog werken met hun invoer- en uitvoerdata (veelal in datastructuren).
        | Het is dan belangrijk om te weten naar wat voor operaties je moet zoeken in de documentatie.
      p
        | De implementatiedetails in datastructuren zullen in de praktijk (grote) gevolgen hebben voor de prestatie-efficiëntie van een algoritme-implementatie of softwaresysteem als geheel.
        | Daarom is het belangrijk om de begrippen adt en datastructuur te onderscheiden.
      p
        | Lists, stacks en queues zijn de belangrijkste adt’s (op de simpele/primitieve types na).
        | Deze helpen je vooral om items af te lopen ‘op rij’ (sequentieel), ook wel
        |
        em lineair
        |
        | genoemd.
        | Hierover leer je meer in het volgende.
  component-section
    div(slot='title') De lijst/list
    p
      | De
      |
      em.term lijst
      |
      | of
      |
      em#term_list.term list
      |
      | is de adt voor een eindige, geordende rij van items/elementen die niet uniek hoeven te zijn.
    p
      | In de volgende video’s legt David Scot Taylor verscheidene adt’s en datastructuren uit op een toegankelijke manier.
    p.bron Lists, Iterators and Abstract Data Types
    component-video(videoid='B4y8Sb2O4H0', title='Lists, Iterators and Abstract Data Types')
    p.bron
      a(href='https://opendsa-server.cs.vt.edu/ODSA/Books/CS3/html/ListADT.html') Lists
    component-section
      div(slot='title')
        a(href='https://ans.app/digital_test/assignments/295009/routing') Itereren (op Ans)
      component-exercise
    component-section
      div(slot='title') Waarom je lists leert
      p
        | Iedere programmeur heeft al weleens met een list gewerkt.
        | Zelfs een gewone array uit Java is in essentie een datastructuur voor een list.
        | Die arrayimplementatie voldoet aan
        a(href='#term_list') de definitie van list
        | , maar sommige operaties (bijvoorbeeld aan het begin of einde ervan een element toevoegen) zijn standaard niet in één functie (bijvoorbeeld method) geïmplementeerd.
    component-section
      div(slot='title') De gelinkte lijst/linked list
      p
        | Een
        |
        em.term gelinkte lijst
        |
        | of
        |
        em.term linked list
        |
        | is een datastructuur voor een list, bestaande uit
        |
        em nodes
        | .
        | Een node bestaat uit het element (de inhoud) en verwijzingen naar de volgende en soms ook vorige node.
        | In het laatste geval heet het een
        |
        em.term tweevoudig gelinkte lijst
        |
        | of
        |
        em.term doubly-linked list
        | .
        | De elementen staan niet per se opeenvolgend aansluitend in het geheugen (dus: niet lineair in het geheugen, wel sequentieel af te lopen).
        | De verwijzingen zijn
        |
        em pointers
        |
        | of
        |
        em references
        |
        | (programmeertaalafhankelijk) naar een geheugenobject.
      p.bron Linked Lists
      component-video(videoid='14g1YBvx8Co', title='Linked Lists')
      p.bron
        a(href='https://opendsa-server.cs.vt.edu/ODSA/Books/CS3/html/ListLinked.html') Linked Lists
      p.bron
        a(href='https://opendsa-server.cs.vt.edu/ODSA/Books/CS3/html/ListDouble.html') Doubly Linked Lists
      component-section.praktijk
        div(slot='title') Waarom je gelinkte lijsten leert
        p
          | Alle niet-embedded softwaresystemen gebruiken geheugenallocatoren voor de heap (
          code.lang-c malloc()
          | ).
          | De implementatie van een geheugenallocator
          a(href='http://staffwww.fullcoll.edu/aclifton/cs241/lecture-dynamic-mem-linked-lists.html') gebruikt vaak gelinkte lijsten
          | .
        p
          | Ook de processenlijst van het Linux-besturingssysteem is gebaseerd op gelinkte lijsten.
        p
          | Gelinkte lijsten zijn een mogelijke onderliggende datastructuur voor andere datastructuren, zoals stacks, queues, hashtabellen en grafen.
        p
          | Tweevoudig gelinkte lijsten zouden gebruikt kunnen worden voor iets als een terug- en vooruitfunctie (bijvoorbeeld in een web browser).
        p
          | Gelinkte lijsten worden vaker gebruikt dan alternatieve lijsten als het aantal elementen niet bekend is of vast mag liggen, en willekeurige toegang tot elementen niet nodig is (bijvoorbeeld voor sorteren).
      component-section
        div(slot='title')
          a(href='https://ans.app/digital_test/assignments/297244/routing') Gelinkte lijsten en geheugenruimte (op Ans)
        component-exercise
      component-section
        div(slot='title')
          a(href='https://ans.app/digital_test/assignments/297587/routing') Sentinel node (op Ans)
        component-exercise
    component-section
      div(slot='title') De dynamische rij/dynamic array
      p
        em.term Dynamische rijen
        |
        | of
        |
        em.term dynamic arrays
        |
        | zijn ook wel bekend als
        |
        em.term vectors
        | .
        | Dynamische rijen hebben geen vaste lengte, statische (gewone) arrays wel.
        | Hierdoor zijn ze erg veelzijdig, en misschien wel de mééstgebruikte datastructuur ooit.
      p
        | In de volgende video’s legt David Scot Taylor dynamische rijen uit.
        | Hij stelt de praktijk centraal, wat zijn uitleg voor hbo’ers erg goed maakt, vergeleken met de meer academische video’s die je her en der kan vinden.
        | Zijn uitleg over geamortiseerde algoritmeanalyse hoef je trouwens niet te leren voor ADP.
      p.bron Dynamic Arrays, aka ArrayLists
      component-video(videoid='0XC9lFGGpME', title='Dynamic Arrays, aka ArrayLists')
      component-section
        div(slot='title')
          a(href='https://ans.app/digital_test/assignments/297594/routing') Array access (op Ans)
        component-exercise
      component-section
        div(slot='title')
          a(href='https://ans.app/digital_test/assignments/297595/routing')
            code.lang-java ArrayList
            | versus statische rij (op Ans)
        component-exercise
  component-section
    div(slot='title') De stapel/stack
    p
      | De adt
      |
      em.term stapel
      |
      | of
      |
      em.term stack
      |
      | geeft het
      |
      em laatste ingevoegde
      |
      | element als eerste terug (
      em.term last in, first out (lifo)
      | ).
    p.bron Stack Data Structure - Algorithm
    component-video(videoid='niBsGw4h5yI', title='Stack Data Structure - Algorithm')
    p.bron
      a(href='https://opendsa-server.cs.vt.edu/ODSA/Books/CS3/html/StackArray.html') Stacks
  component-section
    div(slot='title') De wachtrij/queue
    p
      | De adt
      |
      em.term wachtrij
      | of
      |
      em.term queue
      |
      | geeft het
      |
      em vroegst ingevoegde
      |
      | element als eerste terug (
      em.term first in, first out (fifo)
      | ).
    p.bron Queue Data Structure - Algorithm
    component-video(videoid='jXMqVpAVyMY', title='Queue Data Structure - Algorithm')
    p.bron
      a(href='https://opendsa-server.cs.vt.edu/ODSA/Books/CS3/html/Queue.html') Queues
    component-section
      div(slot='title') De prioriteitswachtrij/priority queue
      p
        | De adt
        |
        em.term prioriteitswachtrij
        |
        | of
        |
        em.term priority queue
        |
        | is qua interface identiek aan een queue, maar de operaties hebben een andere betekenis.
        | In plaats van dat het
        |
        em vroegst ingevoegde
        |
        | element als eerste teruggegeven wordt, wordt telkens het
        |
        em kleinste
        |
        | element teruggegeven.
        | Alternatief kan telkens het
        |
        em grootste
        | element teruggegeven.
        | Algemener gezegd, wordt telkens het element met de hoogste prioriteit teruggegeven.
  component-section
    div(slot='title') Van stacks en queues naar de deque
    p
      | David Scot Taylor legt het verband uit tussen stacks, queues en een nog generiekere adt:
      em.term deques
      | .
    p.bron Stacks, Queues and Double Ended Queues (Deques)
    component-video(videoid='IITnvmnfi_Y', title='Stacks, Queues and Double Ended Queues (Deques)')
  component-section
    div(slot='title') Generic programming
    p
      | Het is optimaal om datastructuren ondanks dat ze specifieker zijn dan adt's, wèl generiek te implementeren wat betreft de data die erinpast, in plaats van broncode uit te schrijven voor allerlei verschillende denkbare itemtypes, met veel herhaling.
      | Java is één van de programmeertalen die mogelijkheden biedt voor
      em.term generic programming
      | .
      |
      em Generic
      |
      | betekent net als het Nederlandstalige
      |
      em generiek
      |
      | ‘algemeen’.
      | Generiek is de tegenhanger van
      |
      em specifiek
      | .
      | Generic programming betekent dat je binnen een programmeertaal die dat ondersteunt,
      |
      em regels kan programmeren over welke datatypes geldig zijn
      |
      | op een plaats in de broncode waar types staan.
      | Generiek, want die regels zijn flexibeler en algemener dan ‘de class is exact
      |
      code.lang-java DezeClass
      | ’.
      | Bij Java kan je generic programming toepassen in definities van een method, class of interface.
    p.bron
      a(href='https://docs.oracle.com/javase/tutorial/java/generics/index.html') Lesson: Generics
    p.praktijk
      | Generic programming is nuttig om broncode algemener te maken, dus broncode beter herbruikbaar te maken.
      | Denk bijvoorbeeld aan de volgende toepassingen:
    ul
      li
        p
          | Als je niet wilt casten naar een superklasse, zoals
          |
          code.lang-java Object
          | , maar ook niet een exact datatype kan gebruiken.
      li
        p
          | Als een datastructuur alleen elementen van hetzelfde datatype bevat, kan je broncode eenvoudiger worden en kan je objectcode een hogere prestatie-efficiëntie leveren.
    component-section
      div(slot='title')
        | Vergelijkbaarheid van classes met
        |
        code.lang-java Comparable
      p
        code.lang-java Comparable
        |
        | is een generic interface in Java.
        | Een class kan
        |
        code.lang-java Comparable
        |
        | implementeren, om aan te geven hoe zijn objecten qua inhoud vergeleken worden met (andere) objecten.
      p.bron
        a(href='https://www.baeldung.com/java-comparator-comparable') Comparator and Comparable in Java
        | (negeer
        |
        code.lang-java Comparator
        |
        | als je wilt).
